
// Benchmark

// Inspired by:
// https://eli.thegreenplace.net/2013/12/03/intel-i7-loop-performance-anomaly

// Use:
//   gcc -O2 this.c; time ./a.out

// RESULTS for i5-4690: cca 1.7s without vs 1.5s with call  !

#include <time.h>
#include <stdio.h>

// empty function
void f(void) {}

// test of CPU performance
int main(void) {
    // NOTE: volatile
    volatile unsigned long count=0;

    clock_t start = clock();
    for(unsigned long i=0; i<1000000000UL; ++i) {
        __asm__("call f");      // not optimized away
        count++;
    }
    clock_t end = clock();
    printf("with call: %.3fs\n", ((double)(end-start)/CLOCKS_PER_SEC));

    count=0;
    start = clock();
    for(unsigned long i=0; i<1000000000UL; ++i) {
        count++;
    }
    end = clock();
    printf("no call:   %.3fs\n", ((double)(end-start)/CLOCKS_PER_SEC));

    return count % 16;
}
